<template>
  <table>
    <tr class="dimensions-item-indicator">
      <td class="ecl-u-type-color-black ecl-u-pb-m d-inline-block text-truncate">
        <i class="material-icons align-text-bottom small-icon ecl-u-type-color-blue-n"
          data-placement="right"
          data-toggle="tooltip"
          :title="getIndicatorTooltip">info_outline
        </i>
        {{ indicator }}
      </td>
      <td class="ecl-u-type-color-black ecl-u-pb-m d-inline-block text-truncate bold-text">{{ primaryValue }}%</td>
      <td class="ecl-u-type-color-light-grey ecl-u-pb-m d-inline-block text-truncate">x</td>
      <td class="ecl-u-type-color-black ecl-u-pb-m d-inline-block text-truncate">{{ getWeight }}</td>
      <td class="ecl-u-type-color-light-grey ecl-u-pb-m d-inline-block text-truncate">=</td>
      <td class="ecl-u-type-color-black ecl-u-pb-m d-inline-block text-truncate">{{ getPoints ? getPoints : 0 }}</td>
    </tr>
  </table>
</template>
<script>

import $ from "jquery";

export default {
  name: 'DimensionsItemIndicator',
  props: {
    // Name for this indicator e.g. "License available"
    indicator: {
      type: String,
      default: ''
    },
    indicatorTooltip: {
      type: String,
      default: undefined
    },
    // Array containing every indicator feature value of this indicator
    // e.g. [{name: "yes", percentage: 89}, {name: "no", percentage: 11}]
    values: {
      type: [Array, Object],
      default: []
    },
    filterPrimaryValue: {
      type: [String, Function],
      default: undefined
    },
    displayName: {
      type: Boolean,
      default: false
    },
    scorePoints: {
      type: [Array, Object],
      default: []
    }
  },
  computed: {
    // Returns for this indicator the 'primary' metric, if filterPrimaryValue is set.
    // The filterPrimaryValue can be either a String e.g. '200' or a function.
    // If it's a String, then primaryValue returns a value object for this indicator such that value.name === filterPrimaryValue
    // If it's a function, it will return filterPrimaryValue(values)
    // For example, for indicator 'most frequent acessURLs', the filterPrimaryValue is a function that returns that maximum indicator metric e.g. '200'
    primaryValue() {
      let result;
      if (!this.values || this.values.length === 0) {
        result = null;
      } else {
        let primary = this.filterPrimaryValue ? this.filterPrimaryValue : this.values[0];

        //   // Filter values where name is between 200 and 399
        //   const filteredValues = this.values.filter(value => {
        //     const numName = Number(value.name); // Convert name to number
        //     return numName >= 200 && numName <= 399;
        //   });

        //   // Sum percentages of the filtered values
        //   const totalPercentage = filteredValues.reduce((sum, value) => sum + (typeof value.percentage === 'number' ? value.percentage : 0), 0);

        //   result = filteredValues.length > 0 ? { percentage: totalPercentage } : null;
        // } else {
        const value = this.values.find(value => value.name === primary.name);
        result = value || this.values[0];
      }

      if (result && this.displayName === true) {
        return result.percentage
      }

      return result ? result.percentage : "??"
    },
    getWeight () {
      let result;
      if (!this.values || this.values.length === 0) {
        result = null;
      } else {
        let primary = this.filterPrimaryValue ? this.filterPrimaryValue : this.values[0];
        if (typeof primary === 'function') {
          result = primary(this.values) || this.values[0];
        } else {
          const value = this.values.find(value => value.name === primary.name);
          result = value || this.values[0]
        }
      }

      return !result ? "??" : result.weight
    },
    getPoints () {
      return (this.primaryValue * this.getWeight) / 100
    },
    getIndicatorTooltip () {
      return `${this.indicatorTooltip ? this.indicatorTooltip : this.indicator}`
    },
    percentageHintTooltip () {
      if (!this.displayName || !this.primaryValue) return ''
      return this.primaryValue.percentage ? `${this.primaryValue.percentage}%` : ''
    }
  },
  mounted() {
    $('[data-toggle="tooltip"]').tooltip({container: 'body'});
  }
}
</script>

<style lang="scss" scoped>
@import "@/styles/metrics-style.scss";

  td:first-child {
    width: 50%;
    padding-left: 10px;
  }
  td:not(:first-child) {
    width: 11.25%;
    text-align: center;
  }
  td:last-child {
    width: 5%;
    text-align: center;
  }
  td:last-child {
    text-align: right;
    padding-right: 10px;
  }

  .ecl-u-type-color-light-grey{
    color: #808080 !important;
  }
  .bold-text {
    font-weight: bold !important;
  }
  .material-icons.align-text-bottom{
    display: none;
  }
/*** MATERIAL ICONS ***/
  .material-icons.small-icon {
    font-size: 20px;
  }
  .ecl-u-type-paragraph-m {
    margin: 0!important;
  }
  .indicator {
    display: flex;
    justify-content: space-between;

    .text-truncate{
      color: #000 !important;
    }
    .ecl-u-type-paragraph-m{
      color: #000 !important;
    }
  }
</style>
